(in-package local-time)

(defun mktemp (prefix &key (directory nil))
  (let* ((template (concatenate 'string prefix ".XXXXXX"))
         (process (run-program "/usr/bin/mktemp"
                          (if directory
                              (list "-d" "-t" template)
                              (list "-t" template))
                          :output :stream)))
    (prog1
        (read-line (process-output process) nil nil)
      (process-wait process))))

(defun run (program args)
  (format t "~a ~{~a~^ ~}~%" program args)
  (force-output)
  (run-program program args))

(defun make-distribution (path version)
  (let* ((tmp-dir (mktemp "local-time-dist" :directory t))
         (dst-dir (format nil "~a/local-time-~a" tmp-dir version))
         (src-files (mapcar #'namestring (directory (format nil "~a/*" path))))
         (dst-tgz (format nil "local-time-~a.tar.gz" version)))
    (sb-posix:mkdir dst-dir #o755)
    (run "/usr/bin/cp" (append src-files (list dst-dir)))
    (run "/usr/bin/rm" (list "-rf" ".svn"))
    (run "/usr/bin/rm" (list "-rf" (format nil "~a/*.fasl" dst-dir)))
    (run "/usr/bin/rm" (list "-rf" (format nil "~a/*.tar.gz" dst-dir)))
    (run "/usr/bin/tar" (list "-zcf" dst-tgz dst-dir))
;    (run "/usr/bin/rm" (list "-rf" tmp-dir))
    (run "/usr/bin/gpg" (list "-ba" dst-tgz))
    dst-tgz))
